Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34921)
@@ -3292,12 +5466,29 @@
         push @matches, $lens;
     }
-    return join(' or ', @user) if @user;
-    return join(' or ', @best) if @best;
-    return join(' or ', @matches) if @matches;
-    return $$printConv{$lensType};
+    # return the user-defined lens if it exists
+    if (@user) {
+        # choose the best match if we have more than one
+        if (@user > 1) {
+            my ($try, @good);
+            foreach $try (\@best, \@matches) {
+                $Image::ExifTool::userLens{$_} and push @good, $_ foreach @$try;
+                return join(' or ', @good) if @good;
+            }
+        }
+        return join(' or ', @user);
+    }
+    # return the best match(es) from the possible lenses, after checking against LensModel
+    @best = @matches unless @best;
+    if (@best) {
+        MatchLensModel(\@best, $lensModel);
+        return join(' or ', @best);
+    }
+    $lens = $$printConv{$lensType};
+    return $lensModel if $lensModel and $lens =~ / or /; # (eg. Sony NEX-5N)
+    return $lens;
 }
 
 #------------------------------------------------------------------------------
-# translate date into standard EXIF format
+# Translate date into standard EXIF format
 # Inputs: 0) date
 # Returns: date in format '2003:10:22'
@@ -3308,16 +5499,17 @@
     my $date = shift;
     $date =~ s/\0$//;       # remove any null terminator
-    # separate year:month:day with colons (instead of -, /, space or nothing)
-    $date =~ s/(\d{4})[- \/:]*(\d{2})[- \/:]*(\d{2})$/$1:$2:$3/;
+    # separate year:month:day with colons
+    # (have seen many other characters, including nulls, used erroneously)
+    $date =~ s/(\d{4})[^\d]*(\d{2})[^\d]*(\d{2})$/$1:$2:$3/;
     return $date;
 }
 
 #------------------------------------------------------------------------------
-# translate time into standard EXIF format
+# Translate time into standard EXIF format
 # Inputs: 0) time
 # Returns: time in format '10:30:55'
 # - bad formats recognized: '10 30 55', '103055', '103055+0500'
 # - removes null terminator if it exists
-# - leaves time zone intact if specified (ie. '10:30:55+05:00')
+# - leaves time zone intact if specified (eg. '10:30:55+05:00')
 sub ExifTime($)
 {
@@ -3332,5 +5524,119 @@
 
 #------------------------------------------------------------------------------
-# extract image from file
+# Generate TIFF file from scratch (in current byte order)
+# Inputs: 0) hash of IFD entries (TagID => Value; multiple values space-delimited)
+#         1) raw image data reference
+# Returns: TIFF image data, or undef on error
+sub GenerateTIFF($$)
+{
+    my ($entries, $dataPt) = @_;
+    my ($rtnVal, $tag, $offsetPos);
+
+    my $num = scalar keys %$entries;
+    my $ifdBuff = GetByteOrder() . Set16u(42) .  Set32u(8) .  Set16u($num);
+    my $valBuff = '';
+    my $tagTablePtr = GetTagTable('Image::ExifTool::Exif::Main');
+    foreach $tag (sort { $a <=> $b } keys %$entries) {
+        my $tagInfo = $$tagTablePtr{$tag};
+        my $fmt = ref $tagInfo eq 'HASH' ? $$tagInfo{Writable} : 'int32u';
+        return undef unless defined $fmt;
+        my $val = Image::ExifTool::WriteValue($$entries{$tag}, $fmt, -1);
+        return undef unless defined $val;
+        my $format = $formatNumber{$fmt};
+        $ifdBuff .= Set16u($tag) . Set16u($format) . Set32u(length($val)/$formatSize[$format]);
+        $offsetPos = length($ifdBuff) if $tag == 0x111; # (remember StripOffsets position)
+        if (length $val > 4) {
+            $ifdBuff .= Set32u(10 + 12 * $num + 4 + length($valBuff));
+            $valBuff .= $val;
+        } else {
+            $val .= "\0" x (4 - length($val)) if length $val < 4;
+            $ifdBuff .= $val;
+        }
+    }
+    $ifdBuff .= "\0\0\0\0"; # (no IFD1)
+    return undef unless $offsetPos;
+    Set32u(length($ifdBuff) + length($valBuff), \$ifdBuff, $offsetPos);
+    return $ifdBuff . $valBuff . $$dataPt;
+}
+
+#------------------------------------------------------------------------------
+# Rebuild TIFF thumbnail(s)/preview(s) into stand-alone files with current byte order
+# Inputs: 0) ExifTool ref, 1) SubfileType, 2) Compression, 3) ImageWidth, 4) ImageHeight,
+#         5) BitsPerSample, 6) PhotometricInterpretation, 7) StripOffsets, 8) SamplesPerPixel,
+#         9) RowsPerStrip, 10) StripByteCounts, 10) PlanarConfiguration, 11) Orientation
+# Returns: 0) TIFF image or undef, 1/2) Family 0/1 groups for TIFF preview IFD
+sub RebuildTIFF($;@)
+{
+    local $_;
+    my $et = $_[0];
+    my $value = $$et{VALUE};
+    my ($i, $j, $rtn, $grp0, $grp1);
+    return undef if $$et{FILE_TYPE} eq 'RWZ';
+SubFile:
+    for ($i=0; ; ++$i) {
+        my $key = 'SubfileType' . ($i ? " ($i)" : '');
+        last unless defined $$value{$key};
+        next unless $$value{$key} == 1; # (reduced-resolution image)
+        my $grp = $et->GetGroup($key, 1);
+        my $cmp = $et->FindValue('Compression', $grp);
+        next unless $cmp == 1; # (no compression)
+        my %vals = (Compression=>$cmp, PlanarConfiguration=>1, Orientation=>1);
+        foreach (qw(ImageWidth ImageHeight BitsPerSample PhotometricInterpretation
+                    StripOffsets SamplesPerPixel RowsPerStrip StripByteCounts
+                    PlanarConfiguration Orientation))
+        {
+            my $val = $et->FindValue($_, $grp);
+            defined $val and $vals{$_} = $val, next;
+            next SubFile unless defined $vals{$_};
+        }
+        my ($w, $h) = @vals{'ImageWidth', 'ImageHeight'};
+        my @bits = split ' ', $vals{BitsPerSample};
+        my $rowBytes = 0;
+        $rowBytes += $w * int(($_+7)/8) foreach @bits;
+        my $dat = '';
+        my @off = split ' ', $vals{StripOffsets};
+        my @len = split ' ', $vals{StripByteCounts};
+        # read the image data
+        for ($j=0; $j<@off; ++$j) {
+            next SubFile unless $len[$j] == $rowBytes * $vals{RowsPerStrip};
+            my $tmp = $et->ExtractBinary($off[$j], $len[$j]);
+            next SubFile unless defined $tmp;
+            $dat .= $tmp;
+        }
+        # generate the TIFF image
+        my %entries = (
+            0x0fe => 0,                 # SubfileType = 0
+            0x100 => $w,                # ImageWidth
+            0x101 => $h,                # ImageHeight
+            0x102 => $vals{BitsPerSample},# BitsPerSample
+            0x103 => $vals{Compression},# Compression
+            0x106 => $vals{PhotometricInterpretation}, # PhotometricInterpretation
+            0x111 => 0,                 # StripOffsets (will be adjusted later)
+            0x112 => $vals{Orientation},# Orientation
+            0x115 => $vals{SamplesPerPixel}, # SamplesPerPixel
+            0x116 => $h,                # RowsPerStrip
+            0x117 => $h * $rowBytes,    # StripByteCounts
+            0x11a => 72,                # XResolution = 72
+            0x11b => 72,                # YResolution = 72
+            0x11c => $vals{PlanarConfiguration}, # PlanarConfiguration
+            0x128 => 2,                 # ResolutionUnit = 2
+        );
+        my $img = GenerateTIFF(\%entries, \$dat);
+
+        if (not defined $img) {
+            $et->Warn('Invalid ' . ($w > 256 ? 'Preview' : 'Thumbnail') . 'TIFF data');
+        } elsif ($rtn or $w > 256) { # (call it a preview if larger than 256 pixels)
+            $et->FoundTag('PreviewTIFF', \$img, $et->GetGroup($key));
+        } else {
+            $rtn = \$img;
+            ($grp0, $grp1) = $et->GetGroup($key);
+        }
+    }
+    return $rtn unless wantarray;
+    return ($rtn, $grp0, $grp1);
+}
+
+#------------------------------------------------------------------------------
+# Extract image from file
 # Inputs: 0) ExifTool object reference, 1) data offset (in file), 2) data length
 #         3) [optional] tag name
@@ -3339,11 +5645,11 @@
 sub ExtractImage($$$$)
 {
-    my ($exifTool, $offset, $len, $tag) = @_;
-    my $dataPt = \$exifTool->{EXIF_DATA};
-    my $dataPos = $exifTool->{EXIF_POS};
+    my ($et, $offset, $len, $tag) = @_;
+    my $dataPt = \$$et{EXIF_DATA};
+    my $dataPos = $$et{EXIF_POS};
     my $image;
 
     # no image if length is zero, and don't try to extract binary from XMP file
-    return undef if not $len or $$exifTool{FILE_TYPE} eq 'XMP';
+    return undef if not $len or $$et{FILE_TYPE} eq 'XMP';
 
     # take data from EXIF block if possible
@@ -3351,20 +5657,46 @@
         $image = substr($$dataPt, $offset-$dataPos, $len);
     } else {
-        $image = $exifTool->ExtractBinary($offset, $len, $tag);
+        $image = $et->ExtractBinary($offset, $len, $tag);
         return undef unless defined $image;
         # patch for incorrect ThumbnailOffset in some Sony DSLR-A100 ARW images
-        if ($tag and $tag eq 'ThumbnailImage' and $$exifTool{TIFF_TYPE} eq 'ARW' and
-            $$exifTool{Model} eq 'DSLR-A100' and $offset < 0x10000 and
+        if ($tag and $tag eq 'ThumbnailImage' and $$et{TIFF_TYPE} eq 'ARW' and
+            $$et{Model} eq 'DSLR-A100' and $offset < 0x10000 and
             $image !~ /^(Binary data|\xff\xd8\xff)/)
         {
-            my $try = $exifTool->ExtractBinary($offset + 0x10000, $len, $tag);
+            my $try = $et->ExtractBinary($offset + 0x10000, $len, $tag);
             if (defined $try and $try =~ /^\xff\xd8\xff/) {
                 $image = $try;
-                $exifTool->{VALUE}->{ThumbnailOffset} += 0x10000;
-                $exifTool->Warn('Adjusted incorrect A100 ThumbnailOffset', 1);
+                $$et{VALUE}{ThumbnailOffset} += 0x10000;
+                $et->Warn('Adjusted incorrect A100 ThumbnailOffset', 1);
             }
         }
     }
-    return $exifTool->ValidateImage(\$image, $tag);
+    return $et->ValidateImage(\$image, $tag);
+}
+
+#------------------------------------------------------------------------------
+# Utility routine to return tag ID string for warnings
+# Inputs: 0) Tag ID, 1) [optional] TagInfo ref
+# Returns: "tag 0xXXXX NAME"
+sub TagName($;$)
+{
+    my ($tagID, $tagInfo) = @_;
+    my $tagName = $tagInfo ? ' '.$$tagInfo{Name} : '';
+    return sprintf('tag 0x%.4x%s', $tagID, $tagName);
+}
+
+#------------------------------------------------------------------------------
+# Get class name of next IFD offset for HtmlDump output
+# Inputs: 0) ExifTool ref, 1) current class ID
+# Returns: 0) new IFD offset name, 1) new class ID including "Offset_" for new offset
+#          2) new "Offset_" ID
+sub NextOffsetName($;$)
+{
+    my ($et, $id) = @_;
+    $$et{OffsetNum} = defined $$et{OffsetNum} ? $$et{OffsetNum} + 1 : 0;
+    my $offName = 'o' . $$et{OffsetNum};
+    my $sid = "Offset_$offName";
+    $id = (defined $id ? "$id " : '') . $sid;
+    return ($offName, $id, $sid);
 }
 
@@ -3377,5 +5709,5 @@
 sub ProcessExif($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dataPos = $$dirInfo{DataPos} || 0;
@@ -3387,27 +5719,38 @@
     my $firstBase = $base;
     my $raf = $$dirInfo{RAF};
-    my $verbose = $exifTool->Options('Verbose');
-    my $htmlDump = $exifTool->{HTML_DUMP};
+    my $verbose = $et->Options('Verbose');
+    my $validate = $et->Options('Validate');
+    my $saveFormat = $et->Options('SaveFormat');
+    my $htmlDump = $$et{HTML_DUMP};
     my $success = 1;
-    my ($tagKey, $dirSize, $makerAddr);
-    my $inMakerNotes = $tagTablePtr->{GROUPS}{0} eq 'MakerNotes';
+    my ($tagKey, $dirSize, $makerAddr, $strEnc, %offsetInfo, $offName, $nextOffName);
+    my $inMakerNotes = $$tagTablePtr{GROUPS}{0} eq 'MakerNotes';
+    my $isExif = ($tagTablePtr eq \%Image::ExifTool::Exif::Main);
+
+    # set encoding to assume for strings
+    $strEnc = $et->Options('CharsetEXIF') if $$tagTablePtr{GROUPS}{0} eq 'EXIF';
 
     # ignore non-standard EXIF while in strict MWG compatibility mode
-    if ($Image::ExifTool::MWG::strict and $dirName eq 'IFD0' and
-        $tagTablePtr eq \%Image::ExifTool::Exif::Main and
-        $$exifTool{FILE_TYPE} =~ /^(JPEG|TIFF|PSD)$/)
+    if (($validate or $Image::ExifTool::MWG::strict) and $dirName eq 'IFD0' and
+        $isExif and $$et{FILE_TYPE} =~ /^(JPEG|TIFF|PSD)$/)
     {
-        my $path = $exifTool->MetadataPath();
+        my $path = $et->MetadataPath();
         unless ($path =~ /^(JPEG-APP1-IFD0|TIFF-IFD0|PSD-EXIFInfo-IFD0)$/) {
-            $exifTool->Warn("Ignored non-standard EXIF at $path");
-            return 1;
+            if ($Image::ExifTool::MWG::strict) {
+                $et->Warn("Ignored non-standard EXIF at $path");
+                return 1;
+            } else {
+                $et->Warn("Non-standard EXIF at $path", 1);
+            }
         }
     }
-    $verbose = -1 if $htmlDump; # mix htmlDump into verbose so we can test for both at once
+    # mix htmlDump and Validate into verbose so we can test for all at once
+    $verbose = -1 if $htmlDump;
+    $verbose = -2 if $validate and not $verbose;
     $dirName eq 'EXIF' and $dirName = $$dirInfo{DirName} = 'IFD0';
     $$dirInfo{Multi} = 1 if $dirName =~ /^(IFD0|SubIFD)$/ and not defined $$dirInfo{Multi};
     # get a more descriptive name for MakerNote sub-directories
-    my $name = $$dirInfo{Name};
-    $name = $dirName unless $name and $inMakerNotes and $name !~ /^MakerNote/;
+    my $dir = $$dirInfo{Name};
+    $dir = $dirName unless $dir and $inMakerNotes and $dir !~ /^MakerNote/;
 
     my ($numEntries, $dirEnd);
@@ -3418,7 +5761,9 @@
         $dirEnd = $dirStart + $dirSize;
         if ($dirSize > $dirLen) {
-            if ($verbose > 0 and not $$dirInfo{SubIFD}) {
+            if (($verbose > 0 or $validate) and not $$dirInfo{SubIFD}) {
                 my $short = $dirSize - $dirLen;
-                $exifTool->Warn("Short directory size (missing $short bytes)");
+                $$et{INDENT} =~ s/..$//; # keep indent the same
+                $et->Warn("Short directory size for $dir (missing $short bytes)");
+                $$et{INDENT} .= '| ';
             }
             undef $dirSize if $dirEnd > $dataLen; # read from file if necessary
@@ -3450,17 +5795,22 @@
             }
         }
-        unless ($success) {
-            $exifTool->Warn("Bad $name directory");
-            return 0;
+        if ($success) {
+            $numEntries = Get16u($dataPt, $dirStart);
+        } else {
+            $et->Warn("Bad $dir directory", $inMakerNotes);
+            return 0 unless $inMakerNotes and $dirLen >= 14 and $dirStart >= 0 and
+                            $dirStart + $dirLen <= length($$dataPt);
+            $dirSize = $dirLen;
+            $numEntries = int(($dirSize - 2) / 12); # read what we can
+            Set16u($numEntries, $dataPt, $dirStart);
         }
-        $numEntries = Get16u($dataPt, $dirStart);
         $dirSize = 2 + 12 * $numEntries;
         $dirEnd = $dirStart + $dirSize;
     }
-    $verbose > 0 and $exifTool->VerboseDir($dirName, $numEntries);
+    $verbose > 0 and $et->VerboseDir($dirName, $numEntries);
     my $bytesFromEnd = $dataLen - $dirEnd;
     if ($bytesFromEnd < 4) {
         unless ($bytesFromEnd==2 or $bytesFromEnd==0) {
-            $exifTool->Warn(sprintf"Illegal $name directory size (0x%x entries)",$numEntries);
+            $et->Warn("Illegal $dir directory size ($numEntries entries)");
             return 0;
         }
@@ -3470,5 +5820,5 @@
         $makerAddr = $$dirInfo{MakerNoteAddr};
         delete $$dirInfo{MakerNoteAddr};
-        if (Image::ExifTool::MakerNotes::FixBase($exifTool, $dirInfo)) {
+        if (Image::ExifTool::MakerNotes::FixBase($et, $dirInfo)) {
             $base = $$dirInfo{Base};
             $dataPos = $$dirInfo{DataPos};
@@ -3476,27 +5826,33 @@
     }
     if ($htmlDump) {
-        my $longName = $name eq 'MakerNotes' ? ($$dirInfo{Name} || $name) : $name;
+        $offName = $$dirInfo{OffsetName};
+        my $longName = $dir eq 'MakerNotes' ? ($$dirInfo{Name} || $dir) : $dir;
         if (defined $makerAddr) {
             my $hdrLen = $dirStart + $dataPos + $base - $makerAddr;
-            $exifTool->HDump($makerAddr, $hdrLen, "MakerNotes header", $longName) if $hdrLen > 0;
+            $et->HDump($makerAddr, $hdrLen, "MakerNotes header", $longName) if $hdrLen > 0;
         }
-        $exifTool->HDump($dirStart + $dataPos + $base, 2, "$longName entries",
-                 "Entry count: $numEntries");
+        unless ($$dirInfo{NoDumpEntryCount}) {
+            $et->HDump($dirStart + $dataPos + $base, 2, "$longName entries",
+                       "Entry count: $numEntries", undef, $offName);
+        }
         my $tip;
+        my $id = $offName;
         if ($bytesFromEnd >= 4) {
-            my $nxt = ($name =~ /^(.*?)(\d+)$/) ? $1 . ($2 + 1) : 'Next IFD';
-            $tip = sprintf("$nxt offset: 0x%.4x", Get32u($dataPt, $dirEnd));
+            my $nxt = ($dir =~ /^(.*?)(\d+)$/) ? $1 . ($2 + 1) : 'Next IFD';
+            my $off = Get32u($dataPt, $dirEnd);
+            $tip = sprintf("$nxt offset: 0x%.4x", $off);
+            ($nextOffName, $id) = NextOffsetName($et, $offName) if $off;
         }
-        $exifTool->HDump($dirEnd + $dataPos + $base, 4, "Next IFD", $tip, 0);
+        $et->HDump($dirEnd + $dataPos + $base, 4, "Next IFD", $tip, 0, $id);
     }
 
     # patch for Canon EOS 40D firmware 1.0.4 bug (incorrect directory counts)
     # (must do this before parsing directory or CameraSettings offset will be suspicious)
-    if ($inMakerNotes and $$exifTool{Model} eq 'Canon EOS 40D') {
+    if ($inMakerNotes and $$et{Model} eq 'Canon EOS 40D' and $numEntries) {
         my $entry = $dirStart + 2 + 12 * ($numEntries - 1);
         my $fmt = Get16u($dataPt, $entry + 2);
         if ($fmt < 1 or $fmt > 13) {
-            $exifTool->HDump($entry+$dataPos+$base,12,"[invalid IFD entry]",
-                     "Bad format type: $fmt", 1);
+            $et->HDump($entry+$dataPos+$base,12,"[invalid IFD entry]",
+                       "Bad format type: $fmt", 1, $offName);
             # adjust the number of directory entries
             --$numEntries;
@@ -3505,10 +5861,15 @@
     }
 
+    # make sure that Compression and SubfileType are defined for this IFD (for Condition's)
+    $$et{Compression} = $$et{SubfileType} = '';
+
     # loop through all entries in an EXIF directory (IFD)
-    my ($index, $valEnd, $offList, $offHash);
-    my $warnCount = 0;
+    my ($index, $valEnd, $offList, $offHash, $mapFmt, @valPos);
+    $mapFmt = $$tagTablePtr{VARS}{MAP_FORMAT} if $$tagTablePtr{VARS};
+
+    my ($warnCount, $lastID) = (0, -1);
     for ($index=0; $index<$numEntries; ++$index) {
         if ($warnCount > 10) {
-            $exifTool->Warn("Too many warnings -- $name parsing aborted", 1) and return 0;
+            $et->Warn("Too many warnings -- $dir parsing aborted", 2) and return 0;
         }
         my $entry = $dirStart + 2 + 12 * $index;
@@ -3517,13 +5878,18 @@
         my $count = Get32u($dataPt, $entry+4);
         if ($format < 1 or $format > 13) {
-            $exifTool->HDump($entry+$dataPos+$base,12,"[invalid IFD entry]",
-                     "Bad format type: $format", 1);
-            # warn unless the IFD was just padded with zeros
-            if ($format) {
-                $exifTool->Warn(sprintf("Unknown format ($format) for $name tag 0x%x",$tagID));
-                ++$warnCount;
+            if ($mapFmt and $$mapFmt{$format}) {
+                $format = $$mapFmt{$format};
+            } else {
+                $et->HDump($entry+$dataPos+$base,12,"[invalid IFD entry]",
+                           "Bad format type: $format", 1, $offName);
+                # warn unless the IFD was just padded with zeros
+                if ($format or $validate) {
+                    $et->Warn("Bad format ($format) for $dir entry $index", $inMakerNotes);
+                    ++$warnCount;
+                }
+                # assume corrupted IFD if this is our first entry (except Sony ILCE-7M2 firmware 1.21)
+                return 0 unless $index or $$et{Model} eq 'ILCE-7M2';
+                next;
             }
-            return 0 unless $index; # assume corrupted IFD if this is our first entry
-            next;
         }
         my $formatStr = $formatName[$format];   # get name of this format
@@ -3532,6 +5898,8 @@
         my $valueDataLen = $dataLen;
         my $valuePtr = $entry + 8;      # pointer to value within $$dataPt
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tagID);
-        my $origFormStr;
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tagID);
+        my ($origFormStr, $bad, $rational, $subOffName);
+        # save the EXIF format codes if requested
+        $$et{SaveFormat}{$saveFormat = $formatStr} = 1 if $saveFormat;
         # hack to patch incorrect count in Kodak SubIFD3 tags
         if ($count < 2 and ref $$tagTablePtr{$tagID} eq 'HASH' and $$tagTablePtr{$tagID}{FixCount}) {
@@ -3545,13 +5913,34 @@
             }
         }
+        $validate and not $inMakerNotes and Image::ExifTool::Validate::ValidateExif(
+            $et, $tagTablePtr, $tagID, $tagInfo, $lastID, $dir, $count, $formatStr);
         my $size = $count * $formatSize[$format];
         my $readSize = $size;
         if ($size > 4) {
             if ($size > 0x7fffffff) {
-                $exifTool->Warn(sprintf("Invalid size ($size) for $name tag 0x%x",$tagID));
+                $et->Warn(sprintf("Invalid size (%u) for %s %s",$size,$dir,TagName($tagID,$tagInfo)), $inMakerNotes);
                 ++$warnCount;
                 next;
             }
             $valuePtr = Get32u($dataPt, $valuePtr);
+            if ($validate and not $inMakerNotes) {
+                my $tagName = TagName($tagID, $tagInfo);
+                $et->Warn("Odd offset for $dir $tagName", 1) if $valuePtr & 0x01;
+                if ($valuePtr < 8 || ($valuePtr + $size > length($$dataPt) and
+                                      $valuePtr + $size > $$et{VALUE}{FileSize}))
+                {
+                    $et->Warn("Invalid offset for $dir $tagName");
+                    ++$warnCount;
+                    next;
+                }
+                if ($valuePtr + $size > $dirStart + $dataPos and $valuePtr < $dirEnd + $dataPos + 4) {
+                    $et->Warn("Value for $dir $tagName overlaps IFD");
+                }
+                foreach (@valPos) {
+                    next if $$_[0] >= $valuePtr + $size or $$_[0] + $$_[1] <= $valuePtr;
+                    $et->Warn("Value for $dir $tagName overlaps $$_[2]");
+                }
+                push @valPos, [ $valuePtr, $size, $tagName ];
+            }
             # fix valuePtr if necessary
             if ($$dirInfo{FixOffsets}) {
@@ -3563,8 +5952,8 @@
             my $suspect;
             # offset shouldn't point into TIFF header
-            $valuePtr < 8 and $suspect = $warnCount;
+            $valuePtr < 8 and not $$dirInfo{ZeroOffsetOK} and $suspect = $warnCount;
             # convert offset to pointer in $$dataPt
             if ($$dirInfo{EntryBased} or (ref $$tagTablePtr{$tagID} eq 'HASH' and
-                $tagTablePtr->{$tagID}{EntryBased}))
+                $$tagTablePtr{$tagID}{EntryBased}))
             {
                 $valuePtr += $entry;
@@ -3580,5 +5969,4 @@
                 if ($raf) {
                     # avoid loading large binary data unless necessary
-                    # (ie. ImageSourceData -- layers in Photoshop TIFF image)
                     while ($size > BINARY_DATA_LIMIT) {
                         if ($tagInfo) {
@@ -3586,11 +5974,14 @@
                             $$tagInfo{Binary} = 1 if $$tagInfo{Unknown};
                             last unless $$tagInfo{Binary};      # must read non-binary data
-                            last if $$tagInfo{SubDirectory};    # must read SubDirectory data
-                            if ($exifTool->{OPTIONS}{Binary}) {
+                            last if $$tagInfo{SubDirectory};
+                            my $lcTag = lc($$tagInfo{Name});
+                            if ($$et{OPTIONS}{Binary} and
+                                not $$et{EXCL_TAG_LOOKUP}{$lcTag})
+                            {
                                 # read binary data if specified unless tagsFromFile won't use it
-                                last unless $$exifTool{TAGS_FROM_FILE} and $$tagInfo{Protected};
+                                last unless $$et{TAGS_FROM_FILE} and $$tagInfo{Protected};
                             }
                             # must read if tag is specified by name
-                            last if $exifTool->{REQ_TAG_LOOKUP}{lc($$tagInfo{Name})};
+                            last if $$et{REQ_TAG_LOOKUP}{$lcTag};
                         } else {
                             # must read value if needed for a condition
@@ -3605,25 +5996,44 @@
                     }
                     # read from file if necessary
-                    unless (defined $buff or
-                            ($raf->Seek($base + $valuePtr + $dataPos,0) and
-                             $raf->Read($buff,$size) == $size))
-                    {
-                        $exifTool->Warn("Error reading value for $name entry $index", $inMakerNotes);
-                        return 0 unless $inMakerNotes;
-                        ++$warnCount;
-                        $buff = '' unless defined $buff;
-                        $readSize = length $buff;
+                    unless (defined $buff) {
+                        my $wrn;
+                        my $readFromRAF = ($tagInfo and $$tagInfo{ReadFromRAF});
+                        if (not $raf->Seek($base + $valuePtr + $dataPos, 0)) {
+                            $wrn = "Invalid offset for $dir entry $index";
+                        } elsif ($readFromRAF and $size > BINARY_DATA_LIMIT and
+                            not $$et{REQ_TAG_LOOKUP}{lc $$tagInfo{Name}})
+                        {
+                            $buff = "$$tagInfo{Name} data $size bytes";
+                            $readSize = length $buff;
+                        } elsif ($raf->Read($buff,$size) != $size) {
+                            $wrn = "Error reading value for $dir entry $index";
+                        } elsif ($readFromRAF) {
+                            # seek back to the start of the value
+                            $raf->Seek($base + $valuePtr + $dataPos, 0);
+                        }
+                        if ($wrn) {
+                            $et->Warn($wrn, $inMakerNotes);
+                            return 0 unless $inMakerNotes or $htmlDump;
+                            ++$warnCount;
+                            $buff = '' unless defined $buff;
+                            $readSize = length $buff;
+                            $bad = 1;
+                        }
                     }
+                    $valueDataLen = length $buff;
                     $valueDataPt = \$buff;
                     $valueDataPos = $valuePtr + $dataPos;
-                    $valueDataLen = length $buff;
                     $valuePtr = 0;
                 } else {
-                    my ($tagStr, $tmpInfo);
+                    my ($tagStr, $tmpInfo, $leicaTrailer);
                     if ($tagInfo) {
                         $tagStr = $$tagInfo{Name};
+                        $leicaTrailer = $$tagInfo{LeicaTrailer};
                     } elsif (defined $tagInfo) {
-                        $tmpInfo = $exifTool->GetTagInfo($tagTablePtr, $tagID, \ '', $formatStr, $count);
-                        $tagStr = $$tmpInfo{Name} if $tmpInfo;
+                        $tmpInfo = $et->GetTagInfo($tagTablePtr, $tagID, \ '', $formatStr, $count);
+                        if ($tmpInfo) {
+                            $tagStr = $$tmpInfo{Name};
+                            $leicaTrailer = $$tmpInfo{LeicaTrailer};
+                        }
                     }
                     if ($tagInfo and $$tagInfo{ChangeBase}) {
@@ -3633,37 +6043,39 @@
                         $valuePtr += $newBase;
                     }
-                    $tagStr or $tagStr = sprintf("tag 0x%x",$tagID);
+                    $tagStr or $tagStr = sprintf("tag 0x%.4x",$tagID);
                     # allow PreviewImage to run outside EXIF data
-                    if ($tagStr eq 'PreviewImage' and $exifTool->{RAF}) {
-                        my $pos = $exifTool->{RAF}->Tell();
-                        $buff = $exifTool->ExtractBinary($base + $valuePtr + $dataPos, $size, 'PreviewImage');
-                        $exifTool->{RAF}->Seek($pos, 0);
+                    if ($tagStr eq 'PreviewImage' and $$et{RAF}) {
+                        my $pos = $$et{RAF}->Tell();
+                        $buff = $et->ExtractBinary($base + $valuePtr + $dataPos, $size, 'PreviewImage');
+                        $$et{RAF}->Seek($pos, 0);
                         $valueDataPt = \$buff;
                         $valueDataPos = $valuePtr + $dataPos;
                         $valueDataLen = $size;
                         $valuePtr = 0;
-                    } elsif ($tagStr eq 'MakerNoteLeica6' and $exifTool->{RAF}) {
+                    } elsif ($leicaTrailer and $$et{RAF}) {
                         if ($verbose > 0) {
-                            $exifTool->VPrint(0, "$$exifTool{INDENT}$index) $tagStr --> (outside APP1 segment)\n");
+                            $et->VPrint(0, "$$et{INDENT}$index) $tagStr --> (outside APP1 segment)\n");
                         }
-                        if ($exifTool->Options('FastScan')) {
-                            $exifTool->Warn('Ignored Leica MakerNote trailer');
+                        if ($et->Options('FastScan')) {
+                            $et->Warn('Ignored Leica MakerNote trailer');
                         } else {
-                            $$exifTool{LeicaTrailer} = {
+                            require Image::ExifTool::Fixup;
+                            $$et{LeicaTrailer} = {
                                 TagInfo => $tagInfo || $tmpInfo,
                                 Offset  => $base + $valuePtr + $dataPos,
                                 Size    => $size,
+                                Fixup   => new Image::ExifTool::Fixup,
                             };
                         }
                     } else {
-                        $exifTool->Warn("Bad $name offset for $tagStr");
+                        $et->Warn("Bad offset for $dir $tagStr", $inMakerNotes);
                         ++$warnCount;
                     }
                     unless (defined $buff) {
-                        next unless $htmlDump and $size < 1000000;
-                        $valueDataPt = \ (' ' x $size);
+                        $valueDataPt = '';
                         $valueDataPos = $valuePtr + $dataPos;
-                        $valueDataLen = -1; # flag the bad pointer
+                        $valueDataLen = 0;
                         $valuePtr = 0;
+                        $bad = 1;
                     }
                 }
@@ -3672,5 +6084,5 @@
             if (defined $suspect and $suspect == $warnCount) {
                 my $tagStr = $tagInfo ? $$tagInfo{Name} : sprintf('tag 0x%.4x', $tagID);
-                if ($exifTool->Warn("Suspicious $name offset for $tagStr", $inMakerNotes)) {
+                if ($et->Warn("Suspicious $dir offset for $tagStr", $inMakerNotes)) {
                     ++$warnCount;
                     next unless $verbose;
